#include <iostream>

using namespace std;

int main()
{
    int n,q;cin>>n>>q;
    int a[n]={},p[n]={},b[q]={},suma[n]={},an[q]={},dmg=0;
    for(int i=0;i<n;i++){
        int x,y;
        cin>>x>>y;
        a[i]=x;
        p[i]=y;
        dmg+=a[i];
        suma[i]=dmg;
    }
    for(int i=0;i<q;i++){
        int x; cin>>x; b[q]=x;bool nagy=false;
        for(int j=0;j<n;j++){
            if(suma[j]>=x){
                an[i]=j+1;
                nagy=true;
            }
        }
        if(nagy=false){
            an[i]=-1;
        }
    }
    for(int i=0;i<q;i++){
        cout<<an[i]<<endl;
    }


}